<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

$Pos = json_decode(file_get_contents('php://input'));

$query = "SELECT *,
    (CASE 
        WHEN height IS NOT NULL THEN height 
        WHEN area IS NOT NULL THEN area 
        WHEN Code6 IS NOT NULL THEN Code6 
        WHEN basements IS NOT NULL THEN basements 
        WHEN numberofbuildings IS NOT NULL THEN numberofbuildings 
    END) AS max_value
    FROM QC
    WHERE height IS NOT NULL
    ORDER BY Name, max_value DESC";

$result = $mysqli->query($query);

$return = [];
$personRecords = []; // لتتبع السجلات لكل شخص
if ($result) {
    while ($row = $result->fetch_assoc()) {
        $person = $row['Name'];
        if (!isset($personRecords[$person])) {
            $personRecords[$person] = [];
        }
        
        $personRecords[$person][] = $row;
    }
    
    foreach ($personRecords as $person => $records) {
        $limit = floor(count($records) * 0.1); // حساب 10% من إجمالي السجلات
        $limit = max(4, min($limit, 10)); // تعيين الحد الأدنى إلى 4 والحد الأقصى إلى 10
        
        $selectedRecords = [];
        
        $types = ['area', 'height', 'basements', 'constructiontype', 'structuretype', 'numberofbuildings'];
        
        // اختيار أول ستة مشاريع بناءً على المعايير المحددة
        foreach ($types as $type) {
            $typeRecords = array_filter($records, function ($record) use ($type) {
                return is_numeric($record[$type]); // التحقق من أن القيمة عددية
            });
            
            usort($typeRecords, function ($a, $b) use ($type) {
                return $b[$type] - $a[$type];
            });
            
            if (!empty($typeRecords)) {
                $selectedRecords[] = array_shift($typeRecords);
            }
        }
        
        // اختيار المشاريع المتبقية بشكل عشوائي
        $remainingRecords = array_slice($records, 6); // استبعاد أول ستة مشاريع
        shuffle($remainingRecords);
        $selectedRecords = array_merge($selectedRecords, $remainingRecords);
        
        // التأكد من عدم تجاوز الحد المحسوب
        if (count($selectedRecords) > $limit) {
            $selectedRecords = array_slice($selectedRecords, 0, $limit);
        }
        
        // معالجة وإضافة السجلات المختارة إلى $return
        foreach ($selectedRecords as $record) {
            $return[] = $record;
        }
    }
    
    $return["error"] = false;
}

header('Content-Type: application/json');
echo json_encode($return);
?>
