<?php
try {
    // Step 1: Database Connection
    $dsn = "mysql:host=localhost;dbname=cpvarbia_rd0;charset=utf8mb4";
    $username = "cpvarbia_inspection";
    $password = "CCv4XYNkYG9C";

    // Create a PDO instance
    $pdo = new PDO($dsn, $username, $password);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Step 2: Get all distinct OwnerMobile values
    $ownerMobilesQuery = "SELECT DISTINCT OwnerMobile FROM QC";
    $ownerMobilesStmt = $pdo->query($ownerMobilesQuery);
    $ownerMobiles = $ownerMobilesStmt->fetchAll(PDO::FETCH_COLUMN);

    // Step 3: Prepare an array to store the final results
    $finalResults = [];

    // Step 4: Loop through each OwnerMobile
    foreach ($ownerMobiles as $ownerMobile) {
        // Step 5: Calculate the number of rows for each OwnerMobile
        $countQuery = "SELECT COUNT(*) AS row_count FROM QC WHERE OwnerMobile = :ownerMobile";
        $countStmt = $pdo->prepare($countQuery);
        $countStmt->execute([':ownerMobile' => $ownerMobile]);
        $rowCount = $countStmt->fetch(PDO::FETCH_ASSOC)['row_count'];

        // Calculate 0.03% of the rows (use at least 1 row if the result is less than 1)
        $limit = ceil(0.03 * $rowCount);
        if ($limit < 1) {
            $limit = 1;
        }

        // Step 6: Select 0.03% of the rows for this OwnerMobile
        $selectQuery = "
            SELECT * 
            FROM QC 
            WHERE OwnerMobile = :ownerMobile 
            ORDER BY RAND() 
            LIMIT :limit
        ";
        $selectStmt = $pdo->prepare($selectQuery);
        $selectStmt->bindValue(':ownerMobile', $ownerMobile, PDO::PARAM_STR);
        $selectStmt->bindValue(':limit', (int)$limit, PDO::PARAM_INT);
        $selectStmt->execute();

        // Fetch the rows and add them to the final results array
        $results = $selectStmt->fetchAll(PDO::FETCH_ASSOC);
        $finalResults[$ownerMobile] = $results; // Store by OwnerMobile
    }

    // Step 7: Encode the results as JSON
    $jsonData = json_encode($finalResults, JSON_PRETTY_PRINT);

    // Step 8: Save the JSON data to a file
    $filePath = 'output_data.json'; // You can change the file name and path as needed
    file_put_contents($filePath, $jsonData);

    // Optional: Output a message
    echo "Data has been exported to " . $filePath;
} catch (PDOException $e) {
    // Handle errors
    echo "Error: " . $e->getMessage();
}
?>
