<?php
ob_start('ob_gzhandler');
include('../../api/config.php');

// Adjust the date range to include July, August, and September
$res = $mysqli->query("SELECT Ticket.PStageID, Ticket.TicketID, Ticket.TransferTo, Ticket.Code, 
projects.ReferenceNo, MONTH(Ticket.CreatedAt) as TicketMonth 
FROM Ticket, projects 
WHERE Ticket.ProjectID = projects.ProjectID 
AND Ticket.`CreatedAt` BETWEEN '2024-09-01 00:00:00' AND '2024-09-30 23:59:59' 
AND Ticket.Deleted = '0' 
ORDER BY Ticket.TicketID DESC");

$numrows = mysqli_num_rows($res);
$return = []; // Initialize the return array

if ($numrows > 0) {
    while ($row = $res->fetch_assoc()) {
        $PStageID = $row['PStageID'];
        $ticketData = [
            'TicketID' => $row['TicketID'],
        ];

        // Fetch TransferTo name
        $resx8r = $mysqli->query("SELECT Name FROM `role_resources` WHERE `ResourceID` = '" . $row['TransferTo'] . "'");
        $row8r = mysqli_fetch_array($resx8r);
        $ticketData['TransferTo'] = $row8r['Name'];

        $ticketData['TICode'] = $row['Code'];

        // Fetch Degree and CreatedAt from TicketHistory
        $resx955 = $mysqli->query("SELECT DegreeID FROM `TicketHistory` WHERE `TicketID` = '" . $row['TicketID'] . "' AND DegreeID IS NOT NULL AND `CreatedAt` BETWEEN '2024-09-01 00:00:00' AND '2024-09-30 23:59:59' ORDER BY THID ASC LIMIT 1");
        $ro5967 = mysqli_fetch_array($resx955);

        // Fetch Degree Name
        if (!empty($ro5967['DegreeID'])) {
            $resx9 = $mysqli->query("SELECT `Name` FROM `tickets_degree` WHERE `DegreeID` = '" . $ro5967['DegreeID'] . "'");
            $row967 = mysqli_fetch_array($resx9);
            $ticketData['Degree'] = $row967['Name'] ?? null;
        } else {
            $ticketData['Degree'] = null;
        }

        // Group by ReferenceNo (Project) and Month
        $referenceNo = $row['ReferenceNo'];
        $month = $row['TicketMonth'];
        
        // Initialize project array if not exists
        if (!isset($return[$referenceNo])) {
            $return[$referenceNo] = [];
        }
        
        // Initialize month array if not exists
        if (!isset($return[$referenceNo][$month])) {
            $return[$referenceNo][$month] = [];
        }

        // Add ticket data to the correct month
        $return[$referenceNo][$month][] = $ticketData;
    }
} else {
    $return["error"] = true;
    $return["message"] = "Not Found!";
}

header('Content-Type: application/json');
echo json_encode($return);
?>
