<?php

// Allow from any origin
if (isset($_SERVER['HTTP_ORIGIN'])) {
    // Decide if the origin in $_SERVER['HTTP_ORIGIN'] is one
    // you want to allow, and if so:
    header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
    header('Access-Control-Allow-Credentials: true');
    header('Access-Control-Max-Age: 86400');    // cache for 1 day
}

// Access-Control headers are received during OPTIONS requests
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
        // may also be using PUT, PATCH, HEAD, etc
        header("Access-Control-Allow-Methods: GET, POST, OPTIONS");

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
        header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
    exit(0);
}

$DBhost = "localhost";
$DBusername = "cpvarbia_inspection";
$DBpassword = "CCv4XYNkYG9C";
$DBname = "cpvarbia_BigData";

$mysqli = new mysqli($DBhost, $DBusername, $DBpassword, $DBname);
if (mysqli_connect_error()) {
    printf("Connect Error! %s\n", mysqli_connect_error());
    exit();
}
$mysqli->query("SET character_set_client=utf8");
$mysqli->query("SET character_set_connection=utf8");
$mysqli->query("SET character_set_database=utf8");
$mysqli->query("SET character_set_results=utf8");
$mysqli->query("SET character_set_server=utf8");

date_default_timezone_set("Asia/Riyadh");

$Data = json_decode(file_get_contents('php://input'));
$Token = trim($Data->Token);
//$Token = 'tg5i9fqsl';

if (!empty($Token)) {
      $res11 = $mysqli->query("SELECT `BGID` FROM `Request` WHERE `Token` = '$Token' AND `Deleted` = '0'");

  $numrows11 = mysqli_num_rows($res11);
  if ($numrows11 > 0) {
    $return["error"] = false;
    $row11 = $res11->fetch_assoc();
$res = $mysqli->query("SELECT `ReferenceNo`, `C2`, `C5` FROM `F_Result` WHERE `BGID` = '".$row11['BGID']."'");

$numrows = mysqli_num_rows($res);
$return = array();
$totalProjects = 0;  // Initialize overall total projects count

if ($numrows > 0) {
    $return["error"] = false;

    while ($row = $res->fetch_assoc()) {
        if($row['C2'] == 1){
            $Cityname = 'Eastern Province' ;
        }else if($row['C2'] == 2){
            $Cityname = 'Riyadh';
        }else if($row['C2'] == 3){
            $Cityname = 'Najran';
        }else if($row['C2'] == 4){
            $Cityname = 'Jizan';
        }else  if($row['C2'] == 5){
            $Cityname = 'Asir';
        }else  if($row['C2'] == 6){
            $Cityname = 'Al-Bahah';
        }else  if($row['C2'] == 7){
            $Cityname = 'Mecca';
        }else  if($row['C2'] == 8){
            $Cityname = 'Medina';
        }else  if($row['C2'] == 9){
            $Cityname = 'Al-Qassim';
        }else  if($row['C2'] == 10){
            $Cityname = 'Hail';
        }else  if($row['C2'] == 11){
            $Cityname = 'Northern Borders';
        }else  if($row['C2'] == 12){
            $Cityname = 'Tabuk';
        }else  if($row['C2'] == 13){
            $Cityname = 'Al-Jawf';
        }   
        $groupKey = $Cityname;
        $ZoneKey = $row['C5'];

        // Check if the group key already exists in the $return array
        if (!isset($return[$groupKey])) {
            // If not, initialize it with an empty array
            $return[$groupKey] = array(
                'Totalprojects' => 0,  // Initialize the total projects count for the group
                'Zones' => array()
            );
        }

        // Increment the total projects count for the group
        $return[$groupKey]['Totalprojects']++;

        // Check if the ZoneKey already exists in the Zones array
        if (!isset($return[$groupKey]['Zones'][$ZoneKey])) {
            // If not, initialize it with an empty array
            $return[$groupKey]['Zones'][$ZoneKey] = array(
                'Totalprojectsatzone' => 0,  // Initialize the total projects count for the zone
                'ReferenceNo' => array()
            );
        }

        // Increment the total projects count for the zone
        $return[$groupKey]['Zones'][$ZoneKey]['Totalprojectsatzone']++;

        // Add the ReferenceNo to the respective ZoneKey
        $return[$groupKey]['Zones'][$ZoneKey]['ReferenceNo'][] = $row['ReferenceNo'];

        // Increment the overall total projects count
        $totalProjects++;
    }
}
// Add overall total projects count to the first level of the array
$return["Total"] = $totalProjects;
$return["Link"] = 'cpvarabia.com/BigData/'.$row11['BGID'].'.kml';

} else {
    $return["error"] = true;
    $return["message"] = "No Project Found!";
  }
} else {
  $return["error"] = true;
  $return["message"] = "Access denied!";
}
header('Content-Type: application/json');
echo json_encode($return, JSON_PRETTY_PRINT);
?>
