<?php 
ob_start('ob_gzhandler');
include('../api/config.php');

date_default_timezone_set("Asia/Riyadh");
$TodayIs = date("Y-m-d H:i:s");
$time_now = date("Y-m-d");
$UserID = '27';  // Set UserID, adjust as needed

// Prepare the SQL statement to select ProjectID and Cost from projects and project_costs
$stmt1 = $mysqli->prepare("
    SELECT `projects`.`ProjectID`, `project_costs`.`Cost` 
    FROM `projects`
    JOIN `project_costs` ON `projects`.`ProjectID` = `project_costs`.`ProjectID`
    WHERE `projects`.`ProjectID` NOT IN (SELECT `ProjectID` FROM `project_quotations`) 
    LIMIT 500
");

// Execute the statement
$stmt1->execute();

// Fetch the result
$result = $stmt1->get_result();

// Process each project in the result set
while ($rowx6 = $result->fetch_assoc()) {
    $TheProjectID = $rowx6['ProjectID'];
    $Cost = $rowx6['Cost'];
// Check if project exists
if (!empty($TheProjectID)) {
   
    // For cost less than 800,000
    if ($Cost < 800000) {
        $QTotal = 4000;
        $VAT = 600;
        $PCost = $Cost;
        $VCount = 5;

        // Insert into project_quotations securely
        $stmt2 = $mysqli->prepare("INSERT INTO `project_quotations` (`ProjectID`, `UserID`, `PCost`, `VAT`, `QuotationTotal`, `Sent`, `VCount`) VALUES (?, ?, ?, ?, ?, '0', ?)");
        $stmt2->bind_param('iiddii', $TheProjectID, $UserID, $PCost, $VAT, $QTotal, $VCount);
        $stmt2->execute();
        $last_id = $mysqli->insert_id;
        $stmt2->close();

        // Insert into project_quotations_instalments
       
        $stmt3 = $mysqli->prepare("INSERT INTO `project_quotations_instalments` (`QuotationID`, `UserID`, `Percentage`, `DueDate`, `DueMonth`) VALUES (?, ?, '100', ?, '0')");
        $stmt3->bind_param('iis', $last_id, $UserID, $time_now);
        $stmt3->execute();
        $stmt3->close();
    
    // For cost between 800,001 and 4,000,000
    } elseif ($Cost >= 800001 && $Cost < 4000000) {
        $QTotal = $Cost * 0.005;
        $VAT = $QTotal * 0.15;
        $PCost = $Cost;

        // Determine VCount based on cost ranges
        if ($Cost <= 1500000) {
            $VCount = 5;
        } elseif ($Cost <= 2500000) {
            $VCount = 8;
        } elseif ($Cost <= 5000000) {
            $VCount = 12;
        } elseif ($Cost <= 7500000) {
            $VCount = 16;
        } elseif ($Cost <= 10000000) {
            $VCount = 21;
        } elseif ($Cost <= 12500000) {
            $VCount = 26;
        } elseif ($Cost <= 15000000) {
            $VCount = 31;
        } elseif ($Cost <= 17500000) {
            $VCount = 36;
        } elseif ($Cost <= 20000000) {
            $VCount = $Cost * 0.000002;
        } elseif ($Cost <= 50000000) {
            $VCount = $Cost * 0.0000016;
        } else {
            $VCount = "";
        }

        // Insert into project_quotations securely
        $stmt2 = $mysqli->prepare("INSERT INTO `project_quotations` (`ProjectID`, `UserID`, `PCost`, `VAT`, `QuotationTotal`, `Sent`, `VCount`) VALUES (?, ?, ?, ?, ?, '0', ?)");
        $stmt2->bind_param('iiddii', $TheProjectID, $UserID, $PCost, $VAT, $QTotal, $VCount);
        $stmt2->execute();
        $last_id = $mysqli->insert_id;
        $stmt2->close();

        // Insert into project_quotations_instalments
  
        $stmt3 = $mysqli->prepare("INSERT INTO `project_quotations_instalments` (`QuotationID`, `UserID`, `Percentage`, `DueDate`, `DueMonth`) VALUES (?, ?, '100', ?, '0')");
        $stmt3->bind_param('iis', $last_id, $UserID, $time_now);
        $stmt3->execute();
        $stmt3->close();
    
    // For cost greater than or equal to 4,000,001
    } elseif ($Cost >= 4000001) {
        $QTotal = $Cost * 0.005;
        $VAT = $QTotal * 0.15;
        $PCost = $Cost;

        // Determine VCount based on cost ranges
        if ($Cost <= 1500000) {
            $VCount = 5;
        } elseif ($Cost <= 2500000) {
            $VCount = 8;
        } elseif ($Cost <= 5000000) {
            $VCount = 12;
        } elseif ($Cost <= 7500000) {
            $VCount = 16;
        } elseif ($Cost <= 10000000) {
            $VCount = 21;
        } elseif ($Cost <= 12500000) {
            $VCount = 26;
        } elseif ($Cost <= 15000000) {
            $VCount = 31;
        } elseif ($Cost <= 17500000) {
            $VCount = 36;
        } elseif ($Cost <= 20000000) {
            $VCount = $Cost * 0.000002;
        } elseif ($Cost <= 50000000) {
            $VCount = $Cost * 0.0000016;
        } else {
            $VCount = "";
        }

        // Insert into project_quotations securely
        $stmt2 = $mysqli->prepare("INSERT INTO `project_quotations` (`ProjectID`, `UserID`, `PCost`, `VAT`, `QuotationTotal`, `Sent`, `VCount`) VALUES (?, ?, ?, ?, ?, '0', ?)");
        $stmt2->bind_param('iiddii', $TheProjectID, $UserID, $PCost, $VAT, $QTotal, $VCount);
        $stmt2->execute();
        $stmt2->close();
    } else {
          $QTotal = $Cost * 0.005;
                $VAT = ($Cost * 0.005) * 0.15;
                $GTotal = $QTotal + $VAT;
                $PCost = $Cost;
                
                if ($Cost <= 1500000) {
                    $VCount = 5;
                } elseif ($Cost <= 2500000) {
                    $VCount = 8;
                } elseif ($Cost <= 5000000) {
                    $VCount = 12;
                } elseif ($Cost <= 7500000) {
                    $VCount = 16;
                } elseif ($Cost <= 10000000) {
                    $VCount = 21;
                } elseif ($Cost <= 12500000) {
                    $VCount = 26;
                } elseif ($Cost <= 15000000) {
                    $VCount = 31;
                } elseif ($Cost <= 17500000) {
                    $VCount = 36;
                } elseif ($Cost <= 20000000) {
                    $VCount = $Cost * 0.000002;
                } elseif ($Cost <= 50000000) {
                    $VCount = $Cost * 0.0000016;
                } else {
                    $VCount = "";
                }
                 // Insert into project_quotations securely
        $stmt2 = $mysqli->prepare("INSERT INTO `project_quotations` (`ProjectID`, `UserID`, `PCost`, `VAT`, `QuotationTotal`, `Sent`, `VCount`) VALUES (?, ?, ?, ?, ?, '0', ?)");
        $stmt2->bind_param('iiddii', $TheProjectID, $UserID, $PCost, $VAT, $QTotal, $VCount);
        $stmt2->execute();
        $stmt2->close(); 
    }
} else {
    echo "Project not found!";
}
}
