<?php
ob_start('ob_gzhandler');
include('../api/config.php');

$Data = json_decode(file_get_contents('php://input'));
$PerToken = trim($Data->PerToken);
$PerUserID = trim($Data->PerUserID);
$PerRoleID = trim($Data->PerRoleID);
$Page = trim($Data->Page);
$Ref = trim($Data->Ref);
$Date = trim($Data->Date);
$Status = trim($Data->Status);
$UserID = trim($Data->UserID);
$Last5Days = date('Y-m-d H:i:s', strtotime('-7 days'));

// Token validation
$UserCheck = $mysqli->query("SELECT Token FROM `login_tokens` WHERE `UID` = '$PerUserID' AND `Token` = '$PerToken' LIMIT 1");
$UserCheckRow = mysqli_num_rows($UserCheck);
if ($UserCheckRow == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    if (empty($Page)) {
        $Page = 1;
    }

    // Build conditions for the query
    $RefNo = empty($Ref) ? ' ' : " projects.ReferenceNo LIKE '$Ref%' AND ";
    $Dateis = empty($Date) ? ' ' : " project_stages.StageDate BETWEEN '$Date 00:00:00' AND '$Date 23:59:59' AND ";
    $Statusis = empty($Status) ? ' ' : " project_stages.Status = '$Status' AND ";
    $UserIDsis = empty($UserID) ? ' ' : " project_stages.InspectorID = '$UserID' AND ";

    // Count total records with fixed ticket count logic
    $query = "SELECT COUNT(project_stages.PStageID) as num 
              FROM project_stages 
              JOIN projects ON project_stages.ProjectID = projects.ProjectID 
              WHERE $RefNo $Dateis $Statusis $UserIDsis project_stages.StageID = '10' AND project_stages.Deleted NOT IN ('1', '2')";
    
    $total_pages = mysqli_fetch_array($mysqli->query($query))['num'];

    $limit = 25;
    $start = ($Page - 1) * $limit;

    // Optimized main query with ticket count fix
    $res = $mysqli->query("
       SELECT 
    project_stages.*, 
    projects.ReferenceNo, 
    projects.ProjectID, 
    users.FirstName, 
    users.LastName, 
    building_category.Name as CategoryName, 
    stages.StageName
FROM 
    project_stages
JOIN 
    projects ON project_stages.ProjectID = projects.ProjectID
LEFT JOIN 
    users ON project_stages.InspectorID = users.UserID
LEFT JOIN 
    building_category ON projects.CategoryID = building_category.BCID
LEFT JOIN 
    stages ON project_stages.StageID = stages.StageID
WHERE 
    $RefNo $Dateis $Statusis $UserIDsis 
    project_stages.StageID = '10' 
    AND project_stages.Deleted NOT IN ('1', '2') 
GROUP BY 
    project_stages.PStageID 
ORDER BY 
    project_stages.PStageID DESC 
LIMIT $start, $limit

    ");

    $numrows = mysqli_num_rows($res);
    if ($numrows > 0) {
        $return["error"] = false;
        $ddd = 0;

        while ($row = $res->fetch_assoc()) {
            // Prepare response data
            $return[$ddd]['PStageID'] = $row['PStageID'];
              
            $return[$ddd]['Status'] = $row['Status'];
            $return[$ddd]['InspectorID'] = $row['InspectorID'];
            $return[$ddd]['StageDate'] = $row['StageDate'];
            $return[$ddd]['MissingData'] = $row['MissingData'];
            $return[$ddd]['Rev'] = $row['Rev'];
            $return[$ddd]['Synced'] = $row['Synced'];
            $return[$ddd]['ProjectID'] = $row['ProjectID'];
            $return[$ddd]['ReferenceNo'] = $row['ReferenceNo'];
            $return[$ddd]['FullName'] = $row['FirstName'] . " " . $row['LastName'];
            $return[$ddd]['Category'] = $row['CategoryName'];
     
            $return[$ddd]['StageName'] = $row['StageName'];

            // Generate link logic
            if ($row['StageDate'] >= $Last5Days) {
                if ($row['StageDate'] >= '2024-09-20 23:59:59') {
                    $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0test.php?PStageID=' . $row['PStageID'];
                } elseif ($row['StageDate'] < '2024-09-20 23:59:59' && $row['StageDate'] >= '2024-04-02 23:59:59') {
                    $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0test-20-9.php?PStageID=' . $row['PStageID'];
                } else {
                    $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0.php?PStageID=' . $row['PStageID'];
                }
            } else {
                $link = 'https://cpv.blr1.digitaloceanspaces.com/uploads/word/phpword/Ref_' . $row['ReferenceNo'] . '_S_RD0_' . $row['PStageID'] . '.docx';
                if (@file_get_contents($link)) {
                    $return[$ddd]['Link'] = $link;
                } else {
                    if ($row['StageDate'] >= '2024-09-20 23:59:59') {
                        $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0test.php?PStageID=' . $row['PStageID'];
                    } elseif ($row['StageDate'] < '2024-09-20 23:59:59' && $row['StageDate'] >= '2024-04-02 23:59:59') {
                        $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0test-20-9.php?PStageID=' . $row['PStageID'];
                    } else {
                        $return[$ddd]['Link'] = 'https://inspection.cpvarabia.com/wordlib/vendor/phpoffice/phpword/samples/rd0.php?PStageID=' . $row['PStageID'];
                    }
                }
            }
            $ddd++;
        }

        $lastpage = ceil($total_pages / $limit);
        $return["TotalItems"] = $total_pages;
        $return["TotalPages"] = $lastpage;
        $return["Page"] = $Page;
    } else {
        $return["error"] = true;
        $return["message"] = "Incorrect!";
    }
}

header('Content-Type: application/json');
echo json_encode($return);

?>
