<?php

$apiKey = 'sk-NCdawl5rzD4QtZU3KtQGxiwUZCfgVxt47QacjeYgpAT3BlbkFJb-3aLZxaYV5yPhIeTtUZDb0tigsbQOmYtSnf7LcvwA';

function translateTerm($term, $targetLanguage = 'ar') {
    global $apiKey;
    
    // Adjust the prompt to ask for a full translation if necessary.
    $prompt = "Translate the entire following text from English to {$targetLanguage}: {$term}";

    $data = [
        'model' => 'gpt-4o', // Replace 'gpt-4o-mini' with a valid model name
        'messages' => [
            [
                'role' => 'system', 
                'content' => 'You are a translator specialized in engineering terms.'
            ],
            [
                'role' => 'user', 
                'content' => $prompt
            ]
        ],
        'max_tokens' => 180,
    ];

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, 'https://api.openai.com/v1/chat/completions');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Content-Type: application/json',
        'Authorization: Bearer ' . $apiKey,
    ]);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));

    $response = curl_exec($ch);

    if (curl_errno($ch)) {
        echo 'Error: ' . curl_error($ch);
        return null;
    }

    curl_close($ch);

    $response = json_decode($response, true);

    if (isset($response['error'])) {
        echo 'API Error: ' . $response['error']['message'];
        return null;
    }

    if (isset($response['choices'][0]['message']['content'])) {
        $translatedText = trim($response['choices'][0]['message']['content']);
        
        // Optionally, further processing could be done here to ensure the response meets expectations.
        return $translatedText;
    } else {
        echo 'Error: Invalid response format';
        return null;
    }
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $input = json_decode(file_get_contents('php://input'), true);
    
    if (isset($input['term'])) {
        $term = $input['term'];
        $translation = translateTerm($term);
        
        header('Content-Type: application/json');
        echo json_encode(['term' => $term, 'translation' => $translation]);
    } else {
        header('Content-Type: application/json');
        echo json_encode(['error' => 'Term is required']);
    }
} else {
    header('Content-Type: application/json');
    echo json_encode(['error' => 'Invalid request method']);
}

?>
